'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _convertSourceMap = require('convert-source-map');

var _variable = require('./variable');

var _variable2 = _interopRequireDefault(_variable);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isLargeSource = true;

exports.default = options => input => {
  return function istanbulInstrument(log) {
    const createInstrumenter = require('istanbul-lib-instrument').createInstrumenter;
    const hookRequire = require('istanbul-lib-hook').hookRequire;

    return new Promise(resolve => {
      const instrumenter = createInstrumenter(_extends({}, options, {
        coverageVariable: _variable2.default
      }));

      _hooks2.default.clearAll();

      const hook = hookRequire(
      // hook requires matches input files
      file => {
        return input.indexOf(file) !== -1;
      },
      // and instrument that sources
      (source, file) => {
        let sourceMap = (0, _convertSourceMap.fromSource)(source, isLargeSource);

        if (sourceMap) {
          sourceMap = sourceMap.toObject();
        }

        const result = instrumenter.instrumentSync(source, file, sourceMap);

        log(file);

        return result;
      });

      _hooks2.default.add(hook);
      log('require() is hooked');

      resolve(input);
    });
  };
};