'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _variable = require('./variable');

var _variable2 = _interopRequireDefault(_variable);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  let formats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ['lcovonly', 'text-summary'];
  return input => {
    return function istanbulReport(log) {
      const createCoverageMap = require('istanbul-lib-coverage').createCoverageMap;
      const createSourceMapStore = require('istanbul-lib-source-maps').createSourceMapStore;
      const createReporter = require('istanbul-api').createReporter;

      return new Promise((resolve, reject) => {
        _hooks2.default.clearAll();

        if (!global[_variable2.default]) {
          return reject('no coverage information was collected');
        }

        const coverageMap = createCoverageMap(global[_variable2.default]);
        const sourceMapStore = createSourceMapStore();
        const remappedCoverageMap = sourceMapStore.transformCoverage(coverageMap).map;
        const reporter = createReporter();

        formats.forEach(format => {
          log(format);

          reporter.add(format);
          reporter.write(remappedCoverageMap);
        });

        resolve(input);
      });
    };
  };
};